#include <iostream>
#include <queue>
#include <algorithm>
#include <cstdlib>
using namespace std;

int n, m, maxa=0, mina=500*500;
string b[500];

void bfs(int ys, int xs)
{
  //cout << ys << '/' << xs << endl;
  queue<int> X, Y;
  int a = 0;
  X.push(xs); Y.push(ys);
  b[ys][xs] = 'x';
  while(!X.empty())
  {
    a++;
    int x = X.front(); X.pop();
    int y = Y.front(); Y.pop();
    //cout << y << '-' << x << endl;
    if(x>0 && b[y][x-1]=='.')
    { b[y][x-1]='x'; X.push(x-1); Y.push(y); }
    if(x<n-1 && b[y][x+1]=='.')
    { b[y][x+1]='x'; X.push(x+1); Y.push(y); }
    if(y>0 && b[y-1][x]=='.')
    { b[y-1][x]='x'; X.push(x); Y.push(y-1); }
    if(y<m-1 && b[y+1][x]=='.')
    { b[y+1][x]='x'; X.push(x); Y.push(y+1); }
  }
  /*
  while(!X.empty())
  {
    cout << Y.front()<<'+' << X.front() << endl;
    X.pop(); Y.pop();
  }
  exit(0);*/
  maxa = max(maxa, a);
  mina = min(mina, a);
}

int main()
{
  ios_base::sync_with_stdio(0);
  cin >> n >> m;
  for(int i=0; i<m; i++) cin >> b[i];
  for(int y=0; y<m; y++)
    for(int x=0; x<n; x++)
      if(b[y][x]=='.') bfs(y,x);
  if(maxa==0)
    cout << "0 0" << endl;
  else
    cout << maxa << ' ' << mina << endl;    
  return 0;
}